
/* cift6-c.c -- CIF test 6, C part */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <sys/time.h>
#include <unistd.h>

#include "cifccsp.h"

void my_bsyscall (char *string)
{
	struct timeval tv = {2, 0};

	fprintf (stderr, "the message was [%s]\n", string);
	select (0, NULL, NULL, NULL, &tv);
	fprintf (stderr, "the message was [%s]\n", string);

	return;
}
	

void out_string (char *str, Channel *out)
{
	unsigned char *ch = (unsigned char *)str;

	while (*ch != '\0') {
		/* ChanOut (out, ch, 1); */
		ChanOutChar (out, *ch);
		ch++;
	}
	return;
}

void my_process (Process *me, Channel *kroc_err)
{
	BLOCKING_CALLN (my_bsyscall, "wibble!");
	out_string ("that should have worked!\n", kroc_err);
	return;
}


/* allocates process and returns address to occam world */
void real_cift6_init (int *raddr, Channel *c)
{
	Process *p = ProcAlloc (my_process, 4096, 1, c);

	*raddr = (int)p;
	return;
}

/* frees memory used by a process -- lets hope it's finished :) */
void real_cift6_free (int addr)
{
	Process *p = (Process *)addr;

	ProcAllocClean (p);
	return;
}

void _cift6_init (int *ws) { real_cift6_init ((int *)(ws[0]), (Channel *)(ws[1])); }
void _cift6_free (int *ws) { real_cift6_free ((int)(ws[0])); }

